# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: frequenz/api/common/v1/microgrid/lifetime.proto, frequenz/api/common/v1/microgrid/microgrid.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass
from datetime import datetime
from typing import List

import betterproto

from ... import v1 as __v1__
from .. import grid as _grid__


class MicrogridStatus(betterproto.Enum):
    """MicrogridStatus defines the possible statuses for a microgrid."""

    MICROGRID_STATUS_UNSPECIFIED = 0
    """The status is unspecified. This should not be used."""

    MICROGRID_STATUS_ACTIVE = 1
    """The microgrid is active."""

    MICROGRID_STATUS_INACTIVE = 2
    """The microgrid is inactive."""


@dataclass(eq=False, repr=False)
class Lifetime(betterproto.Message):
    """
    Lifetime captures the timestamps indicating the active operational period
    of a microgrid asset, such as a component, connection, sensor, or any other
    entity with a limited operational lifetime. !!! warning "Permanent
    Deletion"     The `end_timestamp` indicates that the asset has been
    permanently removed     from the system.
    """

    start_timestamp: datetime = betterproto.message_field(1)
    """The timestamp when the asset became operationally active."""

    end_timestamp: datetime = betterproto.message_field(2)
    """Optional timestamp when the asset's operational activity ceased."""


@dataclass(eq=False, repr=False)
class Microgrid(betterproto.Message):
    """
    Microgrid contains details of a specific microgrid. A microgrid is a
    localized grouping of electricity generation, energy storage, and loads
    that normally operates connected to a traditional centralized grid. Each
    microgrid has a unique identifier and is associated with an enterprise
    account. A key feature is that it has a physical location and is situated
    in a delivery area. !!! info "Key Concepts"      - `Physical Location`:
    Geographical coordinates specify the exact        physical location of the
    microgrid.      - `Delivery Area`: Each microgrid is part of a broader
    delivery area,        which is crucial for energy trading and compliance.
    """

    id: int = betterproto.uint64_field(1)
    """Unique identifier of the microgrid."""

    enterprise_id: int = betterproto.uint64_field(2)
    """
    Unique identifier linking this microgrid to its parent enterprise account.
    """

    name: str = betterproto.string_field(3)
    """Name of the microgrid."""

    delivery_area: "_grid__.DeliveryArea" = betterproto.message_field(4)
    """
    The delivery area where the microgrid is located, as identified by a
    specific code.
    """

    location: "__v1__.Location" = betterproto.message_field(5)
    """Physical location of the microgrid, in geographical co-ordinates."""

    status: "MicrogridStatus" = betterproto.enum_field(6)
    """The current status of the microgrid."""

    create_timestamp: datetime = betterproto.message_field(7)
    """
    The UTC timestamp indicating when the microgrid was initially created.
    """


@dataclass(eq=False, repr=False)
class MicrogridComponentIDs(betterproto.Message):
    """A message to link component IDs with their respective microgrid ID."""

    microgrid_id: int = betterproto.uint64_field(1)
    """The ID of the microgrid."""

    component_ids: List[int] = betterproto.uint64_field(2)
    """List of component IDs belonging to this microgrid."""
